/**
 * @license
 * Copyright 2018 Google Inc. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */

/**
 * Karma configuration
 * @param {Object} config configuration
 */
module.exports = function(config) {
  config.set({
    frameworks: ['jasmine', 'karma-typescript'],
    files: [
      './src/*.ts'  // *.tsx for React Jsx
    ],
    preprocessors: {
      '**/*.ts': 'karma-typescript'  // *.tsx for React Jsx
    },
    reporters: ['progress', 'karma-typescript'],
    browsers: ['Chrome'],
    karmaTypescriptConfig: {
      tsconfig: './tsconfig-es2017.json',
      compilerOptions: {module: 'commonjs', sourceMap: true}
    },
    browserNoActivityTimeout: 30000,
    client: {args: ['--grep', config.grep || '']}
  });
};
